--- Package for the DHBW MCT controller (VHDL)

library ieee;
use ieee.std_logic_1164.all;

package MCT_Pack_uP is 
-- types representing opcodes
type OPTYPE is (NOP, LSL, LSR, LDI, LDA, STR, ADD,
  SUB, ANDA, EOR, ORA, JMP, BRBC, BRBS, BCLR, PUSH, POP, CALL, RET);
  
-- data type and address type
subtype P_Type is std_logic_vector(15 downto 0); -- 16-bit of programm code
subtype D_Type is std_logic_vector (7 downto 0); --  8-bit of data
subtype DA_Type is std_logic_vector(9 downto 0); -- 10-bit addresses of data memory
subtype PA_Type is std_logic_vector(7 downto 0); --  8-bit addresses of program memory

-- constants
constant P_Width  : integer := 16;
constant D_Width  : integer := 8;
constant DA_Width : integer := 10;
constant PA_Width : integer := 8;
   
end MCT_Pack_uP;  
		